---
apiVersion: ricoberger.de/v1alpha1
kind: VaultSecret
metadata:
  name: masternode-shared-secret
spec:
  path: k8s-finale/masternode-shared-secret
  keys:
    - MASTERNODE_SHARED_SECRET
  type: Opaque
---
apiVersion: apps/v1
kind: DaemonSet
metadata:
  name: workernode
  labels:
    app: workernode
spec:
  selector:
    matchLabels:
      app: workernode
  updateStrategy:
    type: RollingUpdate
    rollingUpdate:
      maxUnavailable: 10%
  template:
    metadata:
      labels:
        app: workernode
    spec:
      hostNetwork: true
      containers:
        - name: workernode
          image: prologin/workernode
          imagePullPolicy: IfNotPresent
          envFrom:
            - secretRef:
                name: masternode-shared-secret
          env:
            - name: MASTERNODE_HOST
              value: "masternode.cluster.prologin.dev"
            - name: MASTERNODE_PORT
              value: ""
            - name: WORKERNODE_AVAILABLE_SLOTS
              value: "20"
          ports:
            - name: metrics
              containerPort: 9020
          securityContext:
            privileged: true
          livenessProbe:
            httpGet:
              port: metrics
              path: /metrics
            periodSeconds: 10
            initialDelaySeconds: 10
            failureThreshold: 3
            successThreshold: 1
---
apiVersion: monitoring.coreos.com/v1
kind: PodMonitor
metadata:
  name: workernode
spec:
  selector:
    matchLabels:
      app: workernode
  podMetricsEndpoints:
    - port: metrics
      path: /metrics
      interval: 5s
